/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.bico.db.camp.tables;


import de.jottyfan.bico.db.camp.Camp;
import de.jottyfan.bico.db.camp.tables.records.VParticipantRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class VParticipant extends TableImpl<VParticipantRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>camp.v_participant</code>
     */
    public static final VParticipant V_PARTICIPANT = new VParticipant();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VParticipantRecord> getRecordType() {
        return VParticipantRecord.class;
    }

    /**
     * The column <code>camp.v_participant.males</code>.
     */
    public final TableField<VParticipantRecord, Long> MALES = createField(DSL.name("males"), SQLDataType.BIGINT, this, "");

    /**
     * The column <code>camp.v_participant.females</code>.
     */
    public final TableField<VParticipantRecord, Long> FEMALES = createField(DSL.name("females"), SQLDataType.BIGINT, this, "");

    private VParticipant(Name alias, Table<VParticipantRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VParticipant(Name alias, Table<VParticipantRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_participant" as  SELECT sum(
             CASE
                 WHEN (sex = 'männlich'::camp.enum_sex) THEN 1
                 ELSE 0
             END) AS males,
         sum(
             CASE
                 WHEN (sex = 'weiblich'::camp.enum_sex) THEN 1
                 ELSE 0
             END) AS females
        FROM camp.t_registration;
        """), where);
    }

    /**
     * Create an aliased <code>camp.v_participant</code> table reference
     */
    public VParticipant(String alias) {
        this(DSL.name(alias), V_PARTICIPANT);
    }

    /**
     * Create an aliased <code>camp.v_participant</code> table reference
     */
    public VParticipant(Name alias) {
        this(alias, V_PARTICIPANT);
    }

    /**
     * Create a <code>camp.v_participant</code> table reference
     */
    public VParticipant() {
        this(DSL.name("v_participant"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Camp.CAMP;
    }

    @Override
    public VParticipant as(String alias) {
        return new VParticipant(DSL.name(alias), this);
    }

    @Override
    public VParticipant as(Name alias) {
        return new VParticipant(alias, this);
    }

    @Override
    public VParticipant as(Table<?> alias) {
        return new VParticipant(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VParticipant rename(String name) {
        return new VParticipant(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VParticipant rename(Name name) {
        return new VParticipant(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VParticipant rename(Table<?> name) {
        return new VParticipant(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VParticipant where(Condition condition) {
        return new VParticipant(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VParticipant where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VParticipant where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VParticipant where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VParticipant where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VParticipant where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VParticipant where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VParticipant where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VParticipant whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VParticipant whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
