/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.bico.db.public_.tables;


import de.jottyfan.bico.db.public_.Keys;
import de.jottyfan.bico.db.public_.Public;
import de.jottyfan.bico.db.public_.tables.TLesson.TLessonPath;
import de.jottyfan.bico.db.public_.tables.records.TSlotRecord;

import java.time.LocalDate;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.ForeignKey;
import org.jooq.Identity;
import org.jooq.InverseForeignKey;
import org.jooq.Name;
import org.jooq.Path;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.Record;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.UniqueKey;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class TSlot extends TableImpl<TSlotRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.t_slot</code>
     */
    public static final TSlot T_SLOT = new TSlot();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<TSlotRecord> getRecordType() {
        return TSlotRecord.class;
    }

    /**
     * The column <code>public.t_slot.pk_slot</code>.
     */
    public final TableField<TSlotRecord, Integer> PK_SLOT = createField(DSL.name("pk_slot"), SQLDataType.INTEGER.nullable(false).identity(true), this, "");

    /**
     * The column <code>public.t_slot.slot_day</code>.
     */
    public final TableField<TSlotRecord, LocalDate> SLOT_DAY = createField(DSL.name("slot_day"), SQLDataType.LOCALDATE.nullable(false), this, "");

    /**
     * The column <code>public.t_slot.note</code>.
     */
    public final TableField<TSlotRecord, String> NOTE = createField(DSL.name("note"), SQLDataType.CLOB, this, "");

    private TSlot(Name alias, Table<TSlotRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private TSlot(Name alias, Table<TSlotRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.table(), where);
    }

    /**
     * Create an aliased <code>public.t_slot</code> table reference
     */
    public TSlot(String alias) {
        this(DSL.name(alias), T_SLOT);
    }

    /**
     * Create an aliased <code>public.t_slot</code> table reference
     */
    public TSlot(Name alias) {
        this(alias, T_SLOT);
    }

    /**
     * Create a <code>public.t_slot</code> table reference
     */
    public TSlot() {
        this(DSL.name("t_slot"), null);
    }

    public <O extends Record> TSlot(Table<O> path, ForeignKey<O, TSlotRecord> childPath, InverseForeignKey<O, TSlotRecord> parentPath) {
        super(path, childPath, parentPath, T_SLOT);
    }

    /**
     * A subtype implementing {@link Path} for simplified path-based joins.
     */
    public static class TSlotPath extends TSlot implements Path<TSlotRecord> {

        private static final long serialVersionUID = 1L;
        public <O extends Record> TSlotPath(Table<O> path, ForeignKey<O, TSlotRecord> childPath, InverseForeignKey<O, TSlotRecord> parentPath) {
            super(path, childPath, parentPath);
        }
        private TSlotPath(Name alias, Table<TSlotRecord> aliased) {
            super(alias, aliased);
        }

        @Override
        public TSlotPath as(String alias) {
            return new TSlotPath(DSL.name(alias), this);
        }

        @Override
        public TSlotPath as(Name alias) {
            return new TSlotPath(alias, this);
        }

        @Override
        public TSlotPath as(Table<?> alias) {
            return new TSlotPath(alias.getQualifiedName(), this);
        }
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public Identity<TSlotRecord, Integer> getIdentity() {
        return (Identity<TSlotRecord, Integer>) super.getIdentity();
    }

    @Override
    public UniqueKey<TSlotRecord> getPrimaryKey() {
        return Keys.T_LESSONDAY_PKEY;
    }

    @Override
    public List<UniqueKey<TSlotRecord>> getUniqueKeys() {
        return Arrays.asList(Keys.T_LESSONDAY_LESSON_DAY_KEY);
    }

    private transient TLessonPath _tLesson;

    /**
     * Get the implicit to-many join path to the <code>public.t_lesson</code>
     * table
     */
    public TLessonPath tLesson() {
        if (_tLesson == null)
            _tLesson = new TLessonPath(this, null, Keys.T_LESSON__T_LESSON_FK_LESSONDAY_FKEY.getInverseKey());

        return _tLesson;
    }

    @Override
    public TSlot as(String alias) {
        return new TSlot(DSL.name(alias), this);
    }

    @Override
    public TSlot as(Name alias) {
        return new TSlot(alias, this);
    }

    @Override
    public TSlot as(Table<?> alias) {
        return new TSlot(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public TSlot rename(String name) {
        return new TSlot(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public TSlot rename(Name name) {
        return new TSlot(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public TSlot rename(Table<?> name) {
        return new TSlot(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TSlot where(Condition condition) {
        return new TSlot(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TSlot where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TSlot where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TSlot where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TSlot where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TSlot where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TSlot where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public TSlot where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TSlot whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public TSlot whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
