/*
 * This file is generated by jOOQ.
 */
package de.jottyfan.bico.db.public_.tables;


import de.jottyfan.bico.db.public_.Public;
import de.jottyfan.bico.db.public_.tables.records.VLessonRecord;

import java.time.LocalDate;
import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes", "this-escape" })
public class VLesson extends TableImpl<VLessonRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>public.v_lesson</code>
     */
    public static final VLesson V_LESSON = new VLesson();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VLessonRecord> getRecordType() {
        return VLessonRecord.class;
    }

    /**
     * The column <code>public.v_lesson.pk_subject</code>.
     */
    public final TableField<VLessonRecord, Integer> PK_SUBJECT = createField(DSL.name("pk_subject"), SQLDataType.INTEGER, this, "");

    /**
     * The column <code>public.v_lesson.source_name</code>.
     */
    public final TableField<VLessonRecord, String> SOURCE_NAME = createField(DSL.name("source_name"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_lesson.theme</code>.
     */
    public final TableField<VLessonRecord, String> THEME = createField(DSL.name("theme"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_lesson.subtheme</code>.
     */
    public final TableField<VLessonRecord, String> SUBTHEME = createField(DSL.name("subtheme"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>public.v_lesson.slots</code>.
     */
    public final TableField<VLessonRecord, LocalDate[]> SLOTS = createField(DSL.name("slots"), SQLDataType.LOCALDATE.array(), this, "");

    /**
     * The column <code>public.v_lesson.order_nr</code>.
     */
    public final TableField<VLessonRecord, Integer> ORDER_NR = createField(DSL.name("order_nr"), SQLDataType.INTEGER, this, "");

    private VLesson(Name alias, Table<VLessonRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VLesson(Name alias, Table<VLessonRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_lesson" as  SELECT su.pk_subject,
          s.name AS source_name,
          su.theme,
          su.subtheme,
          array_agg(d.slot_day) AS slots,
          su.order_nr
         FROM ((((t_subject su
           LEFT JOIN t_source s ON ((s.pk_source = su.fk_source)))
           LEFT JOIN t_lesson_subject ls ON ((ls.fk_subject = su.pk_subject)))
           LEFT JOIN t_lesson l ON ((l.pk_lesson = ls.fk_lesson)))
           LEFT JOIN t_slot d ON ((d.pk_slot = l.fk_slot)))
        GROUP BY su.pk_subject, s.name, su.theme, su.subtheme, su.order_nr;
        """), where);
    }

    /**
     * Create an aliased <code>public.v_lesson</code> table reference
     */
    public VLesson(String alias) {
        this(DSL.name(alias), V_LESSON);
    }

    /**
     * Create an aliased <code>public.v_lesson</code> table reference
     */
    public VLesson(Name alias) {
        this(alias, V_LESSON);
    }

    /**
     * Create a <code>public.v_lesson</code> table reference
     */
    public VLesson() {
        this(DSL.name("v_lesson"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : Public.PUBLIC;
    }

    @Override
    public VLesson as(String alias) {
        return new VLesson(DSL.name(alias), this);
    }

    @Override
    public VLesson as(Name alias) {
        return new VLesson(alias, this);
    }

    @Override
    public VLesson as(Table<?> alias) {
        return new VLesson(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VLesson rename(String name) {
        return new VLesson(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VLesson rename(Name name) {
        return new VLesson(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VLesson rename(Table<?> name) {
        return new VLesson(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VLesson where(Condition condition) {
        return new VLesson(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VLesson where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VLesson where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VLesson where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VLesson where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VLesson where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VLesson where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VLesson where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VLesson whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VLesson whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
