create table camp.t_age(
	created timestamp without time zone default current_timestamp,
	pk_age int not null primary key generated always as identity,
	name text not null unique,
	age int4range not null unique,
	price numeric(4, 2) not null
);

insert into camp.t_age(name, age, price) values
('Erwachsene', '[21, 120)', 53.50),
('Jugendliche 18-20 J.', '[18, 20]', 50.50),
('Jugendliche 15-17 J.', '[15, 27]', 42.00),
('Teens 12-14 J.', '[12, 14]', 37.00),
('Kinder 6-11 J.', '[6, 11]', 29.50),
('Kinder 2-5 J.', '[2, 5]', 23.00),
('Babies', '[0, 1]', 0.00);

alter table camp.t_registration add column barrier_free boolean default false;
alter table camp.t_registration add column nutrition text;
alter table camp.t_registration add column driver_provide_places int;
alter table camp.t_registration add column want_place_in_car boolean;
alter table camp.t_registration add column diseases text;
alter table camp.t_registration add column require_payment boolean;
alter table camp.t_registration add column fk_age int not null references camp.t_age(pk_age);

create or replace view v_version as
select 6 as version;
